import Base, { ResourcePath } from '../../base-rest-resource';
import { SessionInterface } from '../../auth/session/types';
import { ApiVersion } from '../../base-types';
interface FindArgs {
    session: SessionInterface;
    id: number | string;
    fields?: unknown;
}
interface DeleteArgs {
    session: SessionInterface;
    id: number | string;
}
interface AllArgs {
    [key: string]: unknown;
    session: SessionInterface;
    limit?: unknown;
    since_id?: unknown;
    created_at_min?: unknown;
    created_at_max?: unknown;
    updated_at_min?: unknown;
    updated_at_max?: unknown;
    src?: unknown;
    fields?: unknown;
}
interface CountArgs {
    [key: string]: unknown;
    session: SessionInterface;
    src?: unknown;
}
export declare class ScriptTag extends Base {
    static API_VERSION: ApiVersion;
    protected static NAME: string;
    protected static PLURAL_NAME: string;
    protected static HAS_ONE: {
        [key: string]: typeof Base;
    };
    protected static HAS_MANY: {
        [key: string]: typeof Base;
    };
    protected static PATHS: ResourcePath[];
    static find({ session, id, fields }: FindArgs): Promise<ScriptTag | null>;
    static delete({ session, id }: DeleteArgs): Promise<unknown>;
    static all({ session, limit, since_id, created_at_min, created_at_max, updated_at_min, updated_at_max, src, fields, ...otherArgs }: AllArgs): Promise<ScriptTag[]>;
    static count({ session, src, ...otherArgs }: CountArgs): Promise<unknown>;
    event: string | null;
    src: string | null;
    cache: boolean | null;
    created_at: string | null;
    display_scope: string | null;
    id: number | null;
    updated_at: string | null;
}
export {};
//# sourceMappingURL=script_tag.d.ts.map